#ifndef __DB__DB_TYPE_PH__
#define __DB__DB_TYPE_PH__

void DbTypeIteratorDelete (DbTypeIterator This);
int DbTypeIteratorFinished (DbTypeIterator This);
DbTypeIterator DbTypeIteratorDown (DbTypeIterator This);
DbTypeIterator DbTypeIteratorUp (DbTypeIterator This);
void DbTypeIteratorForth (DbTypeIterator This);
void DbTypeIteratorMoveTo (DbTypeIterator This, char* key);
/* void DbTypeIteratorExtend (DbTypeIterator This); */
void* DbTypeIteratorGetItemAddress (DbTypeIterator This);
DbType DbTypeIteratorGetItemType (DbTypeIterator This);
int DbTypeIteratorStoreChar (DbTypeIterator This, char value);
int DbTypeIteratorStoreShort (DbTypeIterator This, short value);
int DbTypeIteratorStoreInt (DbTypeIterator This, int value);
int DbTypeIteratorStoreFloat (DbTypeIterator This, float value);
int DbTypeIteratorStoreDouble (DbTypeIterator This, double value);
int DbTypeIteratorStoreText (DbTypeIterator This, char* value);
int DbTypeIteratorStoreName (DbTypeIterator This, char* value);
char* DbTypeIteratorGetKey (DbTypeIterator This);
/* void DbTypeStartup (); */
/* void DbTypeCleanup (); */
char* DbTypeName (DbType This);
char* DbTypeCName (DbType This);
char* DbTypeCppName (DbType This);
/* char* DbTypeSubTypeName (DbType This); */
int DbTypeSize (DbType This);
char* DbTypeOutput (DbType This, void* address);
CIterator DbTStructureGiveFieldIterator (DbTStructure This);
/* int DbTypeIsSame (DbType This, DbType other); */
DbType DbTypeGetUsedStructure (DbType This);
DbTypeIterator DbTypeGiveInputIterator (DbType This, void* address);
DbTypeIterator DbTypeGiveOutputIterator (DbType This, void* address);
/* DbTypeIterator DbTypeGiveVisitIterator (DbType This); */
void* DbTypeInstanciate (DbType This);
void DbTypeInit (DbType This, void* address);
void DbTypeErase (DbType This, void* address);
DbType DbTCharNew ();
DbType DbTShortNew ();
DbType DbTIntNew ();
DbType DbTHexaNew ();
DbType DbTFloatNew ();
DbType DbTDoubleNew ();
DbType DbTStringNew ();
DbType DbTReferenceNew (DbType element);
/* DbType DbTVectorFind (DbType element); */
DbType DbTVectorNew (DbType element);
/* DbType DbTMatrixFind (DbType element, int rows, int columns); */
DbType DbTMatrixNew (DbType element, int rows, int columns);
/* DbField DbFieldNew (DbType type, char* name); */
DbType DbFieldType (DbField This);
char* DbFieldGetName (DbField This);
DbType DbTStructureFind (char* name);
int DbTStructureInstall (DbType This);
int DbTStructureUninstall (DbType This);
/* DbType DbTStructureNew (char* name, CLList fields); */
/* int DbTStructureAddClient (DbTStructure This, DbType type); */
int DbTypeIsChar (DbType This);
int DbTypeIsShort (DbType This);
int DbTypeIsInt (DbType This);
int DbTypeIsHexa (DbType This);
int DbTypeIsFloat (DbType This);
int DbTypeIsDouble (DbType This);
int DbTypeIsString (DbType This);
int DbTypeIsReference (DbType This);
int DbTypeIsVector (DbType This);
int DbTypeIsMatrix (DbType This);
int DbTypeIsStructure (DbType This);

#endif /* __DB__DB_TYPE_PH__ */
