#!/bin/csh -f

#---------------------------------------------------
#
#  Transfert d'objects Db entre deux domaines Db.
#
#  $1   object_names
#  $2   source domain
#  $3   dest domain
#
#---------------------------------------------------


if ( $#argv < 3 ) then
  echo "> transfer.sh <object names> <source domain> <dest domain>"
  exit 1
endif

set object_names="$1"
set source_domain=$2
set dest_domain=$3
shift
shift
shift

source $DBROOT/cmt/setup.csh

setenv DBDOMAIN ${source_domain}
dbdomain

set db=$DBROOT/$DBCONFIG/db.exe

foreach object ( `${db} object_names "${object_names}"` )
  echo Reading object ${object}
  set name=`basename $object`
  ${db} load_object ${object} >${name}.db
end

setenv DBDOMAIN ${dest_domain}
dbdomain

foreach file ( `ls *.db` )
  echo "Creating object from file $file"
  ${db} create_object -f $file
  rm $file
end

