#ifndef lint
static char const 
DbTypeYYrcsid[] = "$FreeBSD: src/usr.bin/yacc/skeleton.c,v 1.28 2000/01/17 02:04:06 bde Exp $";
#endif
#include <stdlib.h>
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYLEX DbTypeYYlex()
#define YYEMPTY -1
#define DbTypeYYclearin (DbTypeYYchar=(YYEMPTY))
#define DbTypeYYerrok (DbTypeYYerrflag=0)
#define YYRECOVERING() (DbTypeYYerrflag!=0)
static int DbTypeYYgrowstack();
#define YYPREFIX "DbTypeYY"

/*-- Include files ----------------------------------------------*/
#include <stdarg.h>
#include <ctype.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#define alloca malloc
/*---------------------------------------------------------------*/

/*---------------------------------------------------------------*/
#include <Db.h>
/*---------------------------------------------------------------*/


/*-- Prototypes -------------------------------------------------*/
#define DbTypeYYparse DbTypeSemanticAnalyzer
#define DbTypeYYerror DbTypeLexicalError
#define DbTypeYYerrlab DbTypeErrLbl
#define DbTypeYYerrflag DbTypeErrFlg

int DbTypeSemanticAnalyzer ();
int DbTypeYYlex ();

typedef enum
{
  TypeDefinition,
  TypeRedefinition
} ParserMode;

typedef struct
{
  ParserMode       mode;
  DbType           type;
  DbType           field_type;
  DbTypeIterator   type_iterator;
  CLList           lists;
} ParserContext;

typedef struct
{
  char* buffer;
  int current_position;
  int line_number;
  char* old_line_start;
  char* line_start;
} LexContext;

static ParserContext* Context = NULL;
static LexContext*    Lex_context = NULL;
 
int DbTypeLexLineNumber ();
char* DbTypeLexLineStart ();
int DbTypeLexPos ();
void DbTypeLexRestoreContext (LexContext* context);
LexContext* DbTypeLexStartup (LexContext* context, char* text);

static int DbTypeLexicalError(char* s);
static CLList AddFields (CLList list, CLList fields);
/*---------------------------------------------------------------*/
typedef union
{
  DbField     field;
  CLList      list;
  DbObject    object;
  DbType      type;
  double      real;
  int         number;
  char*       string;
} YYSTYPE;
#define YYERRCODE 256
#define STRUCTURE 257
#define NAME 258
#define OPEN_BRACE 259
#define CLOSE_BRACE 260
#define COMMA 261
#define SHORT 262
#define INT 263
#define HEXA 264
#define FLOAT 265
#define DOUBLE 266
#define CHARACTER 267
#define STRING 268
#define REFERENCE 269
#define OPEN_SQUARE 270
#define CLOSE_SQUARE 271
#define LOWER 272
#define GREATER 273
#define NUMBER 274
const short DbTypeYYlhs[] = {                                        -1,
    0,    0,    8,    1,    4,    4,    5,    5,    9,    6,
   10,    6,    7,    7,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    3,    3,    3,
};
const short DbTypeYYlen[] = {                                         2,
    0,    1,    0,    6,    0,    1,    1,    2,    0,    3,
    0,    3,    1,    3,    1,    1,    1,    1,    1,    1,
    1,    1,    4,    1,    1,    3,    7,    4,
};
const short DbTypeYYdefred[] = {                                      0,
    0,    0,    2,    3,    0,    0,   25,   24,   16,   17,
   18,   19,   20,   15,   21,    0,    0,   11,    0,    0,
    7,    0,    0,    0,    0,    4,    8,    0,    0,   26,
    0,   13,    0,    0,   23,   28,    0,    0,    0,   14,
    0,   27,
};
const short DbTypeYYdgoto[] = {                                       2,
    3,   17,   18,   19,   20,   21,   33,    5,   24,   25,
};
const short DbTypeYYsindex[] = {                                   -255,
 -254,    0,    0,    0, -253, -211,    0,    0,    0,    0,
    0,    0,    0,    0,    0, -269, -265,    0, -252, -211,
    0, -211, -256, -251, -251,    0,    0, -264, -261,    0,
 -260,    0, -249, -249,    0,    0, -250, -244, -242,    0,
 -237,    0,
};
const short DbTypeYYrindex[] = {                                     22,
    0,    0,    0,    0,    0, -224,    0,    0,    0,    0,
    0,    0,    0,    0,    0, -257, -212,    0,    0, -210,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, -239, -225,    0,    0,    0,    0,    0,    0,
    0,    0,
};
const short DbTypeYYgindex[] = {                                      0,
    0,   26,    0,    0,    0,   29,   34,    0,    0,    0,
};
#define YYTABLESIZE 59
const short DbTypeYYtable[] = {                                      29,
   22,    1,   22,    4,   23,    6,   32,   26,   35,   36,
   37,   38,   22,   40,   30,   22,   10,   31,   10,   39,
   10,    1,   10,   10,   10,   10,   10,   10,   10,   10,
   12,   41,   12,   42,   12,    5,   12,   12,   12,   12,
   12,   12,   12,   12,    7,    9,    8,   28,   27,    6,
    9,   10,   11,   12,   13,   14,   15,   16,   34,
};
const short DbTypeYYcheck[] = {                                     256,
  258,  257,  272,  258,  270,  259,  258,  260,  273,  271,
  271,  261,  270,  258,  271,  273,  256,  274,  258,  270,
  260,    0,  262,  263,  264,  265,  266,  267,  268,  269,
  256,  274,  258,  271,  260,  260,  262,  263,  264,  265,
  266,  267,  268,  269,  256,  258,  258,   22,   20,  260,
  262,  263,  264,  265,  266,  267,  268,  269,   25,
};
#define YYFINAL 2
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 274
#if YYDEBUG
const char * const DbTypeYYname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"STRUCTURE","NAME","OPEN_BRACE",
"CLOSE_BRACE","COMMA","SHORT","INT","HEXA","FLOAT","DOUBLE","CHARACTER",
"STRING","REFERENCE","OPEN_SQUARE","CLOSE_SQUARE","LOWER","GREATER","NUMBER",
};
const char * const DbTypeYYrule[] = {
"$accept : db",
"db :",
"db : defstructure",
"$$1 :",
"defstructure : STRUCTURE NAME $$1 OPEN_BRACE opt_fields CLOSE_BRACE",
"opt_fields :",
"opt_fields : fields",
"fields : field",
"fields : fields field",
"$$2 :",
"field : basic_field_type $$2 field_names",
"$$3 :",
"field : field_set $$3 field_names",
"field_names : NAME",
"field_names : field_names COMMA NAME",
"basic_field_type : CHARACTER",
"basic_field_type : SHORT",
"basic_field_type : INT",
"basic_field_type : HEXA",
"basic_field_type : FLOAT",
"basic_field_type : DOUBLE",
"basic_field_type : STRING",
"basic_field_type : REFERENCE",
"basic_field_type : REFERENCE LOWER basic_field_type GREATER",
"basic_field_type : NAME",
"basic_field_type : error",
"field_set : basic_field_type OPEN_SQUARE CLOSE_SQUARE",
"field_set : basic_field_type OPEN_SQUARE NUMBER CLOSE_SQUARE OPEN_SQUARE NUMBER CLOSE_SQUARE",
"field_set : basic_field_type OPEN_SQUARE error CLOSE_SQUARE",
};
#endif
#if YYDEBUG
#include <stdio.h>
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH 10000
#endif
#endif
#define YYINITSTACKSIZE 200
int DbTypeYYdebug;
int DbTypeYYnerrs;
int DbTypeYYerrflag;
int DbTypeYYchar;
short *DbTypeYYssp;
YYSTYPE *DbTypeYYvsp;
YYSTYPE DbTypeYYval;
YYSTYPE DbTypeYYlval;
short *DbTypeYYss;
short *DbTypeYYsslim;
YYSTYPE *DbTypeYYvs;
int DbTypeYYstacksize;

/*---------------------------------------------------------------*/
int DbTypeYYwrap ()
/*---------------------------------------------------------------*/
{
  return (1);
}

/*---------------------------------------------------------------*/
static int DbTypeLexicalError (char* s)
/*---------------------------------------------------------------*/
{
  int i;
  char* nl;
  char* start;
  int line_number;

  start = DbTypeLexLineStart ();
  line_number = DbTypeLexLineNumber ();

  fprintf (stderr, "DbType> %s at line %d :\n", s, line_number);

  nl = (char*) strchr (start, '\n');
  if (nl != NULL) *nl = 0;
  fprintf (stderr, "%s\n", start);
  if (nl != NULL) *nl = '\n';

  return (1);
}

/*---------------------------------------------------------------*/
static DbType DbTypeTextAnalyze (ParserMode mode, char* text)
/*---------------------------------------------------------------*/
{
  ParserContext context;
  ParserContext* previous_context = Context;
  LexContext* previous_lex_context;
  LexContext lex_context;
  DbType result = NULL;

  Context = &context;

  Context->mode          = mode;
  Context->type          = NULL;
  Context->field_type    = NULL;
  Context->type_iterator = NULL;
  Context->lists         = NULL;
  
  GCReferenceAssign (Context->lists, CLListNew ());
  
  previous_lex_context = DbTypeLexStartup (&lex_context, text);
  
  DbTypeSemanticAnalyzer ();
  DbTypeLexRestoreContext (previous_lex_context);
  
  CLListErase (Context->lists);
  GCReferenceClear (Context->lists);
  
  result = Context->type;
  
  Context = previous_context;
  
  return (result);
}

/*---------------------------------------------------------------*/
DbType DbParserCreateType (char* text)
/*---------------------------------------------------------------*/
{
  DbType type;

  type = DbTypeTextAnalyze (TypeDefinition, text);

  return (type);
}

/*---------------------------------------------------------------*/
DbType DbParserChangeType (char* text)
/*---------------------------------------------------------------*/
{
  DbType type;

  type = DbTypeTextAnalyze (TypeRedefinition, text);

  return (type);
}

/*---------------------------------------------------------------*/
static CLList AddFields (CLList list, CLList fields)
/*---------------------------------------------------------------*/
{
  CLList result = list;

  if (fields != NULL)
    {
      CIterator it;

      it = CLListGiveIterator (fields);
      for (; !CIteratorFinished (it); CIteratorForth (it))
        {
          DbField field;

          field = (DbField) CIteratorItem (it);

          if (result == NULL)
            {
              result = CLListNew ();
              CLListAdd (Context->lists, result);
            }
          CLListAdd (result, field);
        }
      
      CIteratorDelete (it);
      
      CLListErase (fields);
      CLListRemove (Context->lists, fields);
    }

  return (result);
}
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int DbTypeYYgrowstack()
{
    int newsize, i;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = DbTypeYYstacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;
    i = DbTypeYYssp - DbTypeYYss;
    newss = DbTypeYYss ? (short *)realloc(DbTypeYYss, newsize * sizeof *newss) :
      (short *)malloc(newsize * sizeof *newss);
    if (newss == NULL)
        return -1;
    DbTypeYYss = newss;
    DbTypeYYssp = newss + i;
    newvs = DbTypeYYvs ? (YYSTYPE *)realloc(DbTypeYYvs, newsize * sizeof *newvs) :
      (YYSTYPE *)malloc(newsize * sizeof *newvs);
    if (newvs == NULL)
        return -1;
    DbTypeYYvs = newvs;
    DbTypeYYvsp = newvs + i;
    DbTypeYYstacksize = newsize;
    DbTypeYYsslim = DbTypeYYss + newsize - 1;
    return 0;
}

#define YYABORT goto DbTypeYYabort
#define YYREJECT goto DbTypeYYabort
#define YYACCEPT goto DbTypeYYaccept
#define YYERROR goto DbTypeYYerrlab

#ifndef YYPARSE_PARAM
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG void
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif	/* ANSI-C/C++ */
#else	/* YYPARSE_PARAM */
#ifndef YYPARSE_PARAM_TYPE
#define YYPARSE_PARAM_TYPE void *
#endif
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG YYPARSE_PARAM_TYPE YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL YYPARSE_PARAM_TYPE YYPARSE_PARAM;
#endif	/* ANSI-C/C++ */
#endif	/* ! YYPARSE_PARAM */

int
DbTypeYYparse (YYPARSE_PARAM_ARG)
    YYPARSE_PARAM_DECL
{
    register int DbTypeYYm, DbTypeYYn, DbTypeYYstate;
#if YYDEBUG
    register const char *DbTypeYYs;

    if ((DbTypeYYs = getenv("YYDEBUG")))
    {
        DbTypeYYn = *DbTypeYYs;
        if (DbTypeYYn >= '0' && DbTypeYYn <= '9')
            DbTypeYYdebug = DbTypeYYn - '0';
    }
#endif

    DbTypeYYnerrs = 0;
    DbTypeYYerrflag = 0;
    DbTypeYYchar = (-1);

    if (DbTypeYYss == NULL && DbTypeYYgrowstack()) goto DbTypeYYoverflow;
    DbTypeYYssp = DbTypeYYss;
    DbTypeYYvsp = DbTypeYYvs;
    *DbTypeYYssp = DbTypeYYstate = 0;

DbTypeYYloop:
    if ((DbTypeYYn = DbTypeYYdefred[DbTypeYYstate])) goto DbTypeYYreduce;
    if (DbTypeYYchar < 0)
    {
        if ((DbTypeYYchar = DbTypeYYlex()) < 0) DbTypeYYchar = 0;
#if YYDEBUG
        if (DbTypeYYdebug)
        {
            DbTypeYYs = 0;
            if (DbTypeYYchar <= YYMAXTOKEN) DbTypeYYs = DbTypeYYname[DbTypeYYchar];
            if (!DbTypeYYs) DbTypeYYs = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, DbTypeYYstate, DbTypeYYchar, DbTypeYYs);
        }
#endif
    }
    if ((DbTypeYYn = DbTypeYYsindex[DbTypeYYstate]) && (DbTypeYYn += DbTypeYYchar) >= 0 &&
            DbTypeYYn <= YYTABLESIZE && DbTypeYYcheck[DbTypeYYn] == DbTypeYYchar)
    {
#if YYDEBUG
        if (DbTypeYYdebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, DbTypeYYstate, DbTypeYYtable[DbTypeYYn]);
#endif
        if (DbTypeYYssp >= DbTypeYYsslim && DbTypeYYgrowstack())
        {
            goto DbTypeYYoverflow;
        }
        *++DbTypeYYssp = DbTypeYYstate = DbTypeYYtable[DbTypeYYn];
        *++DbTypeYYvsp = DbTypeYYlval;
        DbTypeYYchar = (-1);
        if (DbTypeYYerrflag > 0)  --DbTypeYYerrflag;
        goto DbTypeYYloop;
    }
    if ((DbTypeYYn = DbTypeYYrindex[DbTypeYYstate]) && (DbTypeYYn += DbTypeYYchar) >= 0 &&
            DbTypeYYn <= YYTABLESIZE && DbTypeYYcheck[DbTypeYYn] == DbTypeYYchar)
    {
        DbTypeYYn = DbTypeYYtable[DbTypeYYn];
        goto DbTypeYYreduce;
    }
    if (DbTypeYYerrflag) goto DbTypeYYinrecovery;
#if defined(lint) || defined(__GNUC__)
    goto DbTypeYYnewerror;
#endif
DbTypeYYnewerror:
    DbTypeYYerror("syntax error");
#if defined(lint) || defined(__GNUC__)
    goto DbTypeYYerrlab;
#endif
DbTypeYYerrlab:
    ++DbTypeYYnerrs;
DbTypeYYinrecovery:
    if (DbTypeYYerrflag < 3)
    {
        DbTypeYYerrflag = 3;
        for (;;)
        {
            if ((DbTypeYYn = DbTypeYYsindex[*DbTypeYYssp]) && (DbTypeYYn += YYERRCODE) >= 0 &&
                    DbTypeYYn <= YYTABLESIZE && DbTypeYYcheck[DbTypeYYn] == YYERRCODE)
            {
#if YYDEBUG
                if (DbTypeYYdebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *DbTypeYYssp, DbTypeYYtable[DbTypeYYn]);
#endif
                if (DbTypeYYssp >= DbTypeYYsslim && DbTypeYYgrowstack())
                {
                    goto DbTypeYYoverflow;
                }
                *++DbTypeYYssp = DbTypeYYstate = DbTypeYYtable[DbTypeYYn];
                *++DbTypeYYvsp = DbTypeYYlval;
                goto DbTypeYYloop;
            }
            else
            {
#if YYDEBUG
                if (DbTypeYYdebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *DbTypeYYssp);
#endif
                if (DbTypeYYssp <= DbTypeYYss) goto DbTypeYYabort;
                --DbTypeYYssp;
                --DbTypeYYvsp;
            }
        }
    }
    else
    {
        if (DbTypeYYchar == 0) goto DbTypeYYabort;
#if YYDEBUG
        if (DbTypeYYdebug)
        {
            DbTypeYYs = 0;
            if (DbTypeYYchar <= YYMAXTOKEN) DbTypeYYs = DbTypeYYname[DbTypeYYchar];
            if (!DbTypeYYs) DbTypeYYs = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, DbTypeYYstate, DbTypeYYchar, DbTypeYYs);
        }
#endif
        DbTypeYYchar = (-1);
        goto DbTypeYYloop;
    }
DbTypeYYreduce:
#if YYDEBUG
    if (DbTypeYYdebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, DbTypeYYstate, DbTypeYYn, DbTypeYYrule[DbTypeYYn]);
#endif
    DbTypeYYm = DbTypeYYlen[DbTypeYYn];
    DbTypeYYval = DbTypeYYvsp[1-DbTypeYYm];
    switch (DbTypeYYn)
    {
case 2:
{
      DbType type = DbTypeYYvsp[0].type;
    }
break;
case 3:
{
      char* name = DbTypeYYvsp[0].string;
      DbType type = NULL;

      if (Context->mode == TypeDefinition)
        {
          type = DbTStructureFind (name);
              
          if (type == NULL)
            {
              Context->type = DbTStructureNew (name, NULL);
              DbTStructureInstall (Context->type);
            }
          else
            {
              DbSetErrorInfo (DbErrorTypeAlreadyDefined, 
                              "Type %s already defined", 
                              name);

              Context->type = NULL;
            }
        }
      else
        {
          type = DbTStructureFind (name);
              
          if (type == NULL)
            {
              type = DbTStructureNew (name, NULL);
              DbTStructureInstall (type);
            }

          Context->type = type;
        }
    }
break;
case 4:
{
      char* name = DbTypeYYvsp[-4].string;
      CLList fields = DbTypeYYvsp[-1].list;
      DbType type = Context->type;

      if (fields != NULL)
        {
          if (type != NULL)
            {
              DbType new_type = NULL;
                  
              GCReferenceAssign (new_type, DbTStructureNew (name, fields));
                  
              if (new_type != type)
                {
                    /*
                      This situation occurs when an already defined
                      structure (ie. same name) has been redefined
                      (ie. its field list has changed).
                      
                      We must convert all objects and types using 
                      directly or indirectly this structure.
                      
                      Eventually 'type' will be deleted and 'new_type'
                      installed in place of it in the data base.
                      */
                  
                    /*
                      to be done...
                      
                      There will be something like :
                      
                      DbTypeConvert (type, new_type);
                      
                      */
                  CLListErase (fields);
                }
                  
              GCReferenceClear (new_type);
            }
          else
            {
              CLListErase (fields);
            }

          CLListRemove (Context->lists, fields);
        }

      DbTypeYYval.type = type;
    }
break;
case 5:
{
      DbTypeYYval.list = NULL;
    }
break;
case 6:
{
      DbTypeYYval.list = DbTypeYYvsp[0].list;
    }
break;
case 7:
{
      CLList fields = DbTypeYYvsp[0].list;
      CLList result = NULL;

      result = AddFields (result, fields);

      DbTypeYYval.list = result;
    }
break;
case 8:
{
      CLList result = DbTypeYYvsp[-1].list;
      CLList fields = DbTypeYYvsp[0].list;

      if ((fields != NULL) &&
          (result != NULL))
        {
          result = AddFields (result, fields);
        }
      else
        {
          if (fields != NULL)
            {
              CLListErase (fields);
              CLListRemove (Context->lists, fields);
              fields = NULL;
            }

          if (result != NULL)
            {
              CLListErase (result);
              CLListRemove (Context->lists, result);
              result = NULL;
            }
        }

      DbTypeYYval.list = result;
    }
break;
case 9:
{
      DbType type = DbTypeYYvsp[0].type;

      Context->field_type = type;
    }
break;
case 10:
{
      CLList list = DbTypeYYvsp[0].list;

      Context->field_type = NULL;
      DbTypeYYval.list = list;
    }
break;
case 11:
{
      DbType type = DbTypeYYvsp[0].type;

      Context->field_type = type;
    }
break;
case 12:
{
      CLList list = DbTypeYYvsp[0].list;

      Context->field_type = NULL;
      DbTypeYYval.list = list;
    }
break;
case 13:
{
      char* name = DbTypeYYvsp[0].string;
      CLList list = NULL;

      if ((name != NULL) &&
          (Context->field_type != NULL))
        {
          DbField field;

          list = CLListNew ();
          CLListAdd (Context->lists, list);

          field = DbFieldNew (Context->field_type, name);
          CLListAdd (list, field);
        }

      DbTypeYYval.list = list;
    }
break;
case 14:
{
      CLList list = DbTypeYYvsp[-2].list;
      char* name = DbTypeYYvsp[0].string;

      if ((name != NULL) &&
          (list != NULL))
        {
          DbField field;

          if (Context->field_type == NULL)
            {
              CLListErase (list);
              CLListRemove (Context->lists, list);
              list = NULL;
            }
          else
            {
              field = DbFieldNew (Context->field_type, name);
              CLListAdd (list, field);
            }
        }

      DbTypeYYval.list = list;
    }
break;
case 15:
{
      DbTypeYYval.type = DbTCharNew ();
    }
break;
case 16:
{
      DbTypeYYval.type = DbTShortNew ();
    }
break;
case 17:
{
      DbTypeYYval.type = DbTIntNew ();
    }
break;
case 18:
{
      DbTypeYYval.type = DbTHexaNew ();
    }
break;
case 19:
{
      DbTypeYYval.type = DbTFloatNew ();
    }
break;
case 20:
{
      DbTypeYYval.type = DbTDoubleNew ();
    }
break;
case 21:
{
      DbTypeYYval.type = DbTStringNew ();
    }
break;
case 22:
{
      DbTypeYYval.type = DbTReferenceNew (NULL);
    }
break;
case 23:
{
      DbType type = DbTypeYYvsp[-1].type;

      DbTypeYYval.type = DbTReferenceNew (type);
    }
break;
case 24:
{
      char* name = DbTypeYYvsp[0].string;
      DbType type;

      type = DbTStructureFind (name);

      if (type == NULL)
        {
            /*
              Unknown user type
              */
          DbSetErrorInfo (DbErrorUnloadedStructure, "%s", name);
        }

      DbTypeYYval.type = type;
    }
break;
case 25:
{
      DbSetErrorInfo (DbErrorBadFieldSyntax, "DbParse>");
      DbTypeLexicalError ("Bad field basic type specification");

      DbTypeYYval.type = NULL;
    }
break;
case 26:
{
      DbType type = DbTypeYYvsp[-2].type;

      DbTypeYYval.type = DbTVectorNew (type);
    }
break;
case 27:
{
      DbType type = DbTypeYYvsp[-6].type;
      int rows = DbTypeYYvsp[-4].number;
      int columns = DbTypeYYvsp[-1].number;

      DbTypeYYval.type = DbTMatrixNew (type, rows, columns);
    }
break;
case 28:
{
      DbType type = DbTypeYYvsp[-3].type;

      DbSetErrorInfo (DbErrorBadDimension, "DbParse>");
      DbTypeLexicalError ("Bad field set type specification");

      DbTypeYYval.type = NULL;
    }
break;
    }
    DbTypeYYssp -= DbTypeYYm;
    DbTypeYYstate = *DbTypeYYssp;
    DbTypeYYvsp -= DbTypeYYm;
    DbTypeYYm = DbTypeYYlhs[DbTypeYYn];
    if (DbTypeYYstate == 0 && DbTypeYYm == 0)
    {
#if YYDEBUG
        if (DbTypeYYdebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        DbTypeYYstate = YYFINAL;
        *++DbTypeYYssp = YYFINAL;
        *++DbTypeYYvsp = DbTypeYYval;
        if (DbTypeYYchar < 0)
        {
            if ((DbTypeYYchar = DbTypeYYlex()) < 0) DbTypeYYchar = 0;
#if YYDEBUG
            if (DbTypeYYdebug)
            {
                DbTypeYYs = 0;
                if (DbTypeYYchar <= YYMAXTOKEN) DbTypeYYs = DbTypeYYname[DbTypeYYchar];
                if (!DbTypeYYs) DbTypeYYs = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, DbTypeYYchar, DbTypeYYs);
            }
#endif
        }
        if (DbTypeYYchar == 0) goto DbTypeYYaccept;
        goto DbTypeYYloop;
    }
    if ((DbTypeYYn = DbTypeYYgindex[DbTypeYYm]) && (DbTypeYYn += DbTypeYYstate) >= 0 &&
            DbTypeYYn <= YYTABLESIZE && DbTypeYYcheck[DbTypeYYn] == DbTypeYYstate)
        DbTypeYYstate = DbTypeYYtable[DbTypeYYn];
    else
        DbTypeYYstate = DbTypeYYdgoto[DbTypeYYm];
#if YYDEBUG
    if (DbTypeYYdebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *DbTypeYYssp, DbTypeYYstate);
#endif
    if (DbTypeYYssp >= DbTypeYYsslim && DbTypeYYgrowstack())
    {
        goto DbTypeYYoverflow;
    }
    *++DbTypeYYssp = DbTypeYYstate;
    *++DbTypeYYvsp = DbTypeYYval;
    goto DbTypeYYloop;
DbTypeYYoverflow:
    DbTypeYYerror("yacc stack overflow");
DbTypeYYabort:
    return (1);
DbTypeYYaccept:
    return (0);
}
