#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include <Db.h>

/*---------------------------------------------------------------*/
int main (int argc, char* argv[])
/*---------------------------------------------------------------*/
{
  int do_scalars = 0;
  int do_vectors = 0;
  int do_matrices = 0;
  int do_structures = 0;

  int number = 0;

  if (!CmMessageOpenMultipleServer ("DbTCreate"))
    {
      fprintf (stderr, "Bad Cm connection\n");
      exit (0);
    }

  if (argc > 1)
    {
      char* arg = argv[1];

      if (strchr (arg, 's'))
        {
          do_scalars = 1;
        }
      if (strchr (arg, 'v'))
        {
          do_vectors = 1;
        }
      if (strchr (arg, 'm'))
        {
          do_matrices = 1;
        }
      if (strchr (arg, 't'))
        {
          do_structures = 1;
        }

      if (argc > 2)
        {
          arg = argv[2];

          sscanf (arg, "%d", &number);
        }
    }
  else
    {
      do_scalars = 1;
      do_vectors = 1;
      do_matrices = 1;
      do_structures = 1;
    }

    /* Scalars */

  if (do_scalars)
    {
      if ((number == 1) || (number == 0))
        {
          DbCreateObject ("char Virgo/c = 'a'");
	  printf ("Virgo/c creation: %s \n", DbGetErrorName (DbGetError ())); 
        }
      if ((number == 2) || (number == 0))
        {
          DbCreateObject ("short Virgo/s = 123");
	  printf ("Virgo/s creation: %s \n", DbGetErrorName (DbGetError ())); 
        }
      if ((number == 3) || (number == 0))
        {
          DbCreateObject ("int Virgo/i = 12345");
	  printf ("Virgo/i creation: %s \n", DbGetErrorName (DbGetError ())); 
        }
      if ((number == 4) || (number == 0))
        {
          DbCreateObject ("float Virgo/f = 123.456");
	  printf ("Virgo/f creation: %s \n", DbGetErrorName (DbGetError ())); 
        }
      if ((number == 5) || (number == 0))
        {
          DbCreateObject ("double Virgo/d = 1234.5678");
	  printf ("Virgo/d creation: %s \n", DbGetErrorName (DbGetError ())); 
        }
      if ((number == 6) || (number == 0))
        {
          DbCreateObject ("string Virgo/t = \"abcdefgh\"");
	  printf ("Virgo/t creation: %s \n", DbGetErrorName (DbGetError ())); 
        }
      if ((number == 7) || (number == 0))
        {
          DbCreateObject ("reference Virgo/r = a");
	  printf ("Virgo/r creation: %s \n", DbGetErrorName (DbGetError ())); 
        }
    }

    /* Vectors */

  if (do_vectors)
    {
      if ((number == 1) || (number == 0))
        {
          DbCreateObject ("char[] Virgo/vc = {'a' 'b' 'c'}");
	  printf ("Virgo/vc creation: %s \n", DbGetErrorName (DbGetError ())); 
        }
      if ((number == 2) || (number == 0))
        {
          DbCreateObject ("short[] Virgo/vs = { 111 222 333 }");
	  printf ("Virgo/vs creation: %s \n", DbGetErrorName (DbGetError ())); 
        }
      if ((number == 3) || (number == 0))
        {
          DbCreateObject ("int[] Virgo/vi = { 1111 2222 3333 }");
	  printf ("Virgo/vi creation: %s \n", DbGetErrorName (DbGetError ())); 
        }
      if ((number == 4) || (number == 0))
        {
          DbCreateObject ("float[] Virgo/vf = { 111.111 222.222 333.333 }");
	  printf ("Virgo/vf creation: %s \n", DbGetErrorName (DbGetError ())); 
        }
      if ((number == 5) || (number == 0))
        {
          DbCreateObject ("double[] Virgo/vd = { 11111.11111 22222.22222 33333.33333}");
	  printf ("Virgo/vd creation: %s \n", DbGetErrorName (DbGetError ())); 
        }
      if ((number == 6) || (number == 0))
        {
          DbCreateObject ("string[] Virgo/vt = { \"aaaaa\" \"bbbbb\" \"ccccc\" }");
	  printf ("Virgo/vt creation: %s \n", DbGetErrorName (DbGetError ())); 
        }
      if ((number == 7) || (number == 0))
        {
          DbCreateObject ("reference[] Virgo/vr = { a b c }");
	  printf ("Virgo/vr creation: %s \n", DbGetErrorName (DbGetError ())); 
        }
    }
  
    /* Matrices */

  if (do_matrices)
    {
      if ((number == 1) || (number == 0))
        {
          DbCreateObject ("char[2][3] Virgo/mc = { {'a' 'b' 'c'} {'d' 'e' 'f'} }");
	  printf ("Virgo/mc creation: %s \n", DbGetErrorName (DbGetError ())); 
        }
      if ((number == 2) || (number == 0))
        {
          DbCreateObject ("short[2][3] Virgo/ms = { {111 222 333} {444 555 666} }");
	  printf ("Virgo/ms creation: %s \n", DbGetErrorName (DbGetError ())); 
        }
      if ((number == 3) || (number == 0))
        {
          DbCreateObject ("int[2][3] Virgo/mi = { {1111 2222 3333} {4444} }");
	  printf ("Virgo/mi creation: %s \n", DbGetErrorName (DbGetError ())); 
        }
      if ((number == 4) || (number == 0))
        {
          DbCreateObject ("float[2][3] Virgo/mf = { {111.111 222.222 333.333} }");
	  printf ("Virgo/mf creation: %s \n", DbGetErrorName (DbGetError ())); 
        }
      if ((number == 5) || (number == 0))
        {
          DbCreateObject ("double[2][3] Virgo/md = { {11111.11111 22222.22222 33333.33333}}");
	  printf ("Virgo/md creation: %s \n", DbGetErrorName (DbGetError ())); 
        }
      if ((number == 6) || (number == 0))
        {
          DbCreateObject ("string[2][3] Virgo/mt = { {\"aaaaa\" \"bbbbb\" \"ccccc\"} }");
	  printf ("Virgo/mt creation: %s \n", DbGetErrorName (DbGetError ())); 
        }
      if ((number == 7) || (number == 0))
        {
          DbCreateObject ("reference[2][3] Virgo/mr = { {a b c} {e}}");
	  printf ("Virgo/mr creation: %s \n", DbGetErrorName (DbGetError ())); 
        }
    }
  
    /* Structures */

  
  if (do_structures)
    {
      if ((number == 1) || (number == 0))
        {
	  DbCreateObject ("Virgo_A Virgo/a = { i = 1 vs = { \"abcd\" \"efgh\" \"ijkl\" } }");
	  printf ("Virgo/vs creation: %s \n", DbGetErrorName (DbGetError ())); 
        }
      
      if ((number == 2) || (number == 0))
        {
          DbCreateObject ("Virgo_B[] Virgo/va = { { s = { { \"aaa\" \"aab\" \"abb\" \"bbb\" } { \"bbb\" \"bbc\" \"bcc\" \"ccc\" } } i = 1 }  { s = { { \"ddd\" \"ddb\" \"dbb\" \"bbb\" } { \"eee\" \"eec\" \"ecc\" \"ccc\" } } i = 1 }}");
	  printf ("Virgo/va creation: %s \n", DbGetErrorName (DbGetError ())); 
        }
    }
  

  DbPrintError ();

  DbCleanup ();
  CmMessageCleanup ();
    /*
  GCDumpBase ();
  */

  return (0);
}
